#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "symtab.h"
#include "tokenizer.h"

#include "codegen.h"

extern _token tokens;
_token *pTok = &tokens;
extern _symtab symtab[6];
extern long lSymbolIndex[6];

long lnPieces, lnStaticVar, lnFunctions, lnLongs;

_codelist codelist;

long *plnLongsInFunction;

extern long lPosExport;

long generatecode(void)
	{
	_codelist *p = &codelist;
	_codelist *pPrev;
	p->pPrev = NULL;
	bool bAdd;
	lnLongs = 0;
	long lFunctionIndex = -1;
	if (lnFunctions)
		plnLongsInFunction = new long[lnFunctions];

	for (long i = 0; i < lnFunctions; i++)
		plnLongsInFunction[i] = 0;     

	long j;
	bool bFound;
	long lLongsSoFar = 0;
	_symtab *ps;

	while (pTok && pTok->psz)
		{
		if ((pTok->lType != DDW) && (pTok->lType != KW_PIECE) && (pTok->lType != KW_STATIC_VAR) && (pTok->lType != KW_PROC) && (pTok->lType != KW_VAR) &&
			(pTok->lType != DECL_PIECE) && (pTok->lType != DECL_STATIC_VAR) && (pTok->lType != KW_ARGS) && (pTok->lType != NEWPROC) && (pTok->lType != LABEL) &&
			(pTok->lType != END_STMT) && (pTok->lType != COMMA) && (pTok->lType != QUOTEMARK) && (pTok->lType != NOCODE) && (pTok->lType != EMPTY))
			{
			lnLongs++;
			if (lnFunctions)
				plnLongsInFunction[lFunctionIndex]++;
			lLongsSoFar++;
			}

		if (pTok->lType == NEWPROC)
			lFunctionIndex++;

		if (pTok->lType == LABEL)
			{
			bFound = false;
			ps = &symtab[5];
			for (j = 0; (j < lSymbolIndex[5]) && (!bFound); j++)
				{
				if (!strcmp(ps->tok.psz, pTok->psz)) bFound = true;
				if (bFound)
					ps->lIndex = lLongsSoFar; //used to be plnLongsInFunction[lFunctionIndex] but jumps are from the code start (0x2C)
				else ps = ps->pNext;
				}
			}

		pTok = pTok->pNext;
		}

	pTok = &tokens;
	//for (long n = 0; n < lnFunctions; n++)
	//	plnLongsInFunction[n] = 0;

	while (pTok && pTok->psz)
		{
		bAdd = true;
		switch (pTok->lType)
			{
			case MOVE:
				p->lCode = 0x10001000;
				break;
			case TURN:
				p->lCode = 0x10002000;
				break;
			case SPIN:
				p->lCode = 0x10003000;
				break;
			case STOPSPIN:
				p->lCode = 0x10004000;
				break;
			case SHOW:
				p->lCode = 0x10005000;
				break;
			case HIDE:
				p->lCode = 0x10006000;
				break;
			case CACHE:
				p->lCode = 0x10007000;
				break;
			case DONTCACHE:
				p->lCode = 0x10008000;
				break;
			case UNK1:
				p->lCode = 0x10009000;
				break;
			case UNK2:
				p->lCode = 0x1000A000;
				break;
			case MOVENOW:
				p->lCode = 0x1000B000;
				break;
			case TURNNOW:
				p->lCode = 0x1000C000;
				break;
			case SHADE:
				p->lCode = 0x1000D000;
				break;
			case DONTSHADE:
				p->lCode = 0x1000E000;
				break;
			case SFX:
				p->lCode = 0x1000F000;
				break;

			case WAITFORTURN:
				p->lCode = 0x10011000;
				break;
			case WAITFORMOVE:
				p->lCode = 0x10012000;
				break;
			case SLEEP:
				p->lCode = 0x10013000;
				break;

			case UNK3:
				p->lCode = 0x10021000;
				break;
			case PUSHCONSTANT:
				p->lCode = 0x10021001;
				break;
			case PUSHVAR:
				p->lCode = 0x10021002;
				break;
			case PUSHSTATIC:
				p->lCode = 0x10021004;
				break;
			case CREATELOCALVAR:
				p->lCode = 0x10022000;
				break;
			case UNK4:
				p->lCode = 0x10023000;
				break;
			case POPVAR:
				p->lCode = 0x10023002;
				break;
			case POPSTATIC:
				p->lCode = 0x10023004;
				break;
			case STACKFLUSH:
				p->lCode = 0x10024000;
				break;

			case ADD:
				p->lCode = 0x10031000;
				break;
			case SUB:
				p->lCode = 0x10032000;
				break;
			case MUL:
				p->lCode = 0x10033000;
				break;
			case DIV:
				p->lCode = 0x10034000;
				break;
			case AND:
				p->lCode = 0x10035000;
				break;
			case OR:
				p->lCode = 0x10036000;
				break;
			case XOR:
				p->lCode = 0x10037000;
				break;
			case NOT:
				p->lCode = 0x10038000;
				break;

			case RAND:
				p->lCode = 0x10041000;
				break;
			case GETUV:
				p->lCode = 0x10042000;
				break;
			case GET:
				p->lCode = 0x10043000;
				break;
			case SHL:
				p->lCode = 0x10044000;
				break;
			case SAR:
				p->lCode = 0x10045000;
				break;

			case SETL:
				p->lCode = 0x10051000;
				break;
			case SETLE:
				p->lCode = 0x10052000;
				break;
			case SETG:
				p->lCode = 0x10053000;
				break;
			case SETGE:
				p->lCode = 0x10054000;
				break;
			case CMP:
				p->lCode = 0x10055000;
				break;
			case SETE:
				p->lCode = 0x10055000;
				break;
			case SETNE:
				p->lCode = 0x10056000;
				break;
			case LAND:
				p->lCode = 0x10057000;
				break;
			case LOR:
				p->lCode = 0x10058000;
				break;
			case LXOR:
				p->lCode = 0x10059000;
				break;
			case NEG:
				p->lCode = 0x1005A000;
				break;

			case START:
				p->lCode = 0x10061000;
				break;
			case CALL:
				p->lCode = 0x10062000;
				break;
			case UNK7:
				p->lCode = 0x10063000;
				break;
			case JMP:
				p->lCode = 0x10064000;
				break;
			case RET:
				p->lCode = 0x10065000;
				break;
			case JNE:
				p->lCode = 0x10066000;
				break;
			case SIG:
				p->lCode = 0x10067000;
				break;
			case MASK:
				p->lCode = 0x10068000;
				break;

			case EXPLODE:
				p->lCode = 0x10071000;
				break;

			case SET:
				p->lCode = 0x10082000;
				break;
			case ATTACH:
				p->lCode = 0x10083000;
				break;
			case DROP:
				p->lCode = 0x10084000;
				break;

			case COBALT_OPCODE:
				p->lCode = 0x10091000;
				break;

			case UNK8:
				p->lCode = 0x02800000;
				break;

			case NOP:
				p->lCode = 0x0;
				break;

			case EMPTY:
				bAdd = false;
				break;

			case DDW:
				//p->lCode = atol(pTok->psz);
				bAdd = false;
				break;

			case INT:
				p->lCode = strtol(pTok->psz, NULL, 10);
				break;
			case HEX_INT:
				p->lCode = strtol(pTok->psz, NULL, 16);
				break;
			case ANGULAR_INT:
				p->lCode = (long)(strtol(pTok->psz, NULL, 10) * 65536 / 360 /*182.044444f*/);
				break;
			case LINEAR_INT:
				p->lCode = (long)(strtol(pTok->psz, NULL, 10) * 163840);
				break;
			case ANGULAR_HEX_INT:
				p->lCode = (long)(strtol(pTok->psz, NULL, 16) * 65536 / 360 /*182.044444f*/);
				break;
			case LINEAR_HEX_INT:
				p->lCode = (long)(strtol(pTok->psz, NULL, 16) * 163840);
				break;
			case FLOAT:
				p->lCode = (long)strtod(pTok->psz, NULL);
				break;
			case ANGULAR_FLOAT:
				p->lCode = (long)(strtod(pTok->psz, NULL) * 65536 / 360 /*182.044444f*/);
				break;
			case LINEAR_FLOAT:
				p->lCode = (long)(strtod(pTok->psz, NULL) * 163840l);
				break;

			case INVOKE:
				p->lCode = 0x10021001;
				break;
			case DLL_LINK:
				p->lCode = pTok->lMoreInfo + (lnLongs * 4);
				break;

			case KW_PIECE:
			case KW_STATIC_VAR:
			case KW_PROC:
			case KW_ARGS:
			case KW_VAR:
			case DECL_PIECE:
			case DECL_STATIC_VAR:
			case KW_UNRECOGNIZED:
				bAdd = false;
				break;
			case NEWPROC:
				lFunctionIndex++;
				bAdd = false;
				break;

			case END_STMT:
			case COMMA:
			case QUOTEMARK:
				bAdd = false;
				break;
			case LBL_JMP:
				bFound = false;
				ps = &symtab[5];
				for (j = 0; (j < lSymbolIndex[5]) && (!bFound); j++)
					{
					if (!strcmp(ps->tok.psz, pTok->psz))
						bFound = true;
					if (bFound)
						p->lCode = ps->lIndex;
					ps = ps->pNext;
					}
				break;
			case LABEL:
				bAdd = false;
				/*bFound = false;
				ps = &symtab[5];
				for (j = 0; j < lSymbolIndex[5]; j++)
					{
					if (!strcmp(ps->tok.psz, pTok->psz)) bFound = true;
					if (bFound)	ps->lIndex = plnLongsInFunction[lFunctionIndex];
					ps = ps->pNext;
					}*/
				break;
			case NOCODE:
				bAdd = false;
				break;

			default: //for an identifier
				p->lCode = pTok->lType & 16383;
				break;
			}

		if (bAdd)
			{
			pPrev = p;
			p->pNext = (_codelist *)malloc(sizeof(_codelist));
			p = p->pNext;
			p->pPrev = pPrev;
			//lnLongs++;
			//plnLongsInFunction[lFunctionIndex]++;
			}

		pTok = pTok->pNext;
		}

	if (lnLongs)
		{
		p = pPrev;
		if (p && p->pNext)
			free(p->pNext);
		p->pNext = NULL;
		}

	return 0;
	}